

#include <stdlib.h>

#include "windowmode_GB.h"
#include "debug.h"

#include "screenshot.h"
#include "recavi.h"
#include "savecfg.h"
#include "ddblt.h"

/*
extern char usedispfpsf;

extern unsigned char nnnKailleraRecvLag;
extern unsigned char nnnKailleraSendLag;
extern unsigned char nnnKailleraLagDisp;
*/
extern int Mainwindowsbhs;
extern HWND Mainwindowsbh;
int DDColorMatch(IDirectDrawSurface7 * pdds, COLORREF rgb);
extern int g_PreviewMode;
//extern int ddrawblt_8bit(DDSURFACEDESC2 *ddsd, DWORD *palette, unsigned char *bmpd, DWORD height);
extern struct Preview_state g_Preview_State;

extern int DDColorMatch(IDirectDrawSurface7 * pdds, COLORREF rgb);



win32_windowed_GB_screen_mgr::win32_windowed_GB_screen_mgr(HWND wnd_handle)
{
  window_handle = wnd_handle;

  blown_up = 0;

  oldBmp = NULL;
  hBmp = NULL;
  buffer = NULL;

  bmpDC  = NULL;
  screenDC = NULL;
  bmInfo   = NULL;
  lpDD = NULL;
  lpDDSOverlay = NULL;
  lpDDSPrimary = NULL;
  lpDDSBack = NULL;
  lpDDSMsg = NULL;
  clipper=NULL;
  avi_rec = 0;
  avi_counter=0;
  buffer_16bit = NULL;
  BitDepth=0;
  BitGreen=0;
  f_2xsai = 0;
  buffer_16bit_bouble=NULL;

  try {
//	f_2xsai = NESTER_settings.nes.graphics.WindowMode_2xsai;
//	f_2xsai = 0;


	if(DD_OK != DirectDrawCreateEx(NULL, (VOID**)&lpDD, IID_IDirectDraw7, NULL))
		throw "Failed Direct Draw create";
	if(DD_OK != lpDD->SetCooperativeLevel(window_handle, DDSCL_NORMAL))
		throw "Failed SetCooperativeLevel";
	if(!DDPrimaryInit())
		throw "Failed DDPrimaryInit";
	if(NESTER_settings.nes.graphics.WindowModeUseDdrawOverlay){
		if(CheckOverlaySupport() == FALSE){
			LOG("not support overlay" << endl);
			NESTER_settings.nes.graphics.WindowModeUseDdrawOverlay=0;
//			throw "not support overlay";
		}
		if(!DDOverlayInit()){
			LOG("Failed DDOverlayInit" << endl);
			NESTER_settings.nes.graphics.WindowModeUseDdrawOverlay=0;
//			throw "Failed DDOverlayInit";
		}
	}
	if(!NESTER_settings.nes.graphics.WindowModeUseDdrawOverlay){
		if(!create_backsurface())
			throw "Failed DDBackInit";
	}

	if(lpDD->CreateClipper(0,&clipper,NULL)!=DD_OK)
		throw "Failed CreateClipper";
	if(clipper->SetHWnd(0,window_handle)!=DD_OK)
		throw "Failed clipper->SetHWnd";
	if(lpDDSPrimary->SetClipper(clipper)!=DD_OK)
		throw "Failed SetClipper";

    bmInfo = new bitmapInfo;
    if(bmInfo == NULL)
      throw "Out of memory in win32_windowed_GB_screen_mgr::win32_windowed_GB_screen_mgr";

    memset(&bmInfo->bmiHeader, 0x00, sizeof(bmInfo->bmiHeader));
    bmInfo->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    bmInfo->bmiHeader.biWidth = GB_SCREEN_WIDTH<<1; // double size 
    bmInfo->bmiHeader.biHeight = -(GB_SCREEN_HEIGHT<<1); // top-down bitmap 
    bmInfo->bmiHeader.biPlanes = 1;
    bmInfo->bmiHeader.biBitCount = 16;
    bmInfo->bmiHeader.biCompression = BI_RGB;
    bmInfo->bmiHeader.biSizeImage = NULL;
    bmInfo->bmiHeader.biXPelsPerMeter = NULL;
    bmInfo->bmiHeader.biYPelsPerMeter = NULL;

    hBmp = CreateDIBSection(screenDC, (BITMAPINFO*)bmInfo,
                             DIB_RGB_COLORS,
                             (void**)&buffer, NULL, NULL);
    if(!hBmp)
      throw("CreateDIBSection failed in win32_windowed_GB_screen_mgr::win32_windowed_GB_screen_mgr");

    if(screenDC) { ReleaseDC(window_handle, screenDC); screenDC = NULL; }

	if(NESTER_settings.nes.graphics.WindowModeUseDdrawOverlay)
		{
		RECT dest;
		DDCAPS          capsDrv;
		unsigned int    uStretchFactor1000;
		unsigned int    uDestSizeAlign, uSrcSizeAlign;
		POINT pt;
		GetClientRect(window_handle, &dest);
		pt.x=dest.left;
		pt.y=dest.top;
		ClientToScreen(window_handle, &pt);
		ZeroMemory(&ovfx, sizeof(ovfx));
		ovfx.dwSize=sizeof(ovfx);
		ZeroMemory(&capsDrv, sizeof(capsDrv));
		capsDrv.dwSize=sizeof(capsDrv);
		lpDD->GetCaps(&capsDrv, NULL);
		uStretchFactor1000 = capsDrv.dwMinOverlayStretch>1000 ? capsDrv.dwMinOverlayStretch : 1000;
		uDestSizeAlign = capsDrv.dwAlignSizeDest;
		uSrcSizeAlign =  capsDrv.dwAlignSizeSrc;
		GetClientRect(window_handle, &dest);
		//		rs.left=0,rs.top=0, rs.bottom=dest.bottom-dest.top, rs.right=dest.right-dest.left;
		rs.left=0,rs.top=0, rs.bottom=GB_SCREEN_HEIGHT, rs.right=GB_SCREEN_WIDTH;
		rd.left=pt.x,rd.top=pt.y, rd.bottom=rs.bottom+pt.y, rd.right=rs.right+pt.x;
		
		/*    if(capsDrv.dwCaps & DDCAPS_ALIGNSIZESRC && uSrcSizeAlign)
        rs.right -= rs.right % uSrcSizeAlign;
		rd.right  = (rs.right*uStretchFactor1000+999)/1000; // adding 999 takes care of integer truncation problems.
		rd.bottom = rs.bottom*uStretchFactor1000/1000;*/
		g_dwXRatio = (rd.right - rd.left) * 1000 / (rs.right - rs.left);
		g_dwYRatio = (rd.bottom - rd.top) * 1000 / (rs.bottom - rs.top);
		ovfx.dckSrcColorkey.dwColorSpaceLowValue=0;
		ovfx.dckSrcColorkey.dwColorSpaceHighValue=0;
		dwUpdateFlags = DDOVER_SHOW;// | DDOVER_DDFX;
		if(capsDrv.dwCKeyCaps & DDCKEYCAPS_SRCOVERLAY)
			dwUpdateFlags |= DDOVER_KEYSRCOVERRIDE;

		if (capsDrv.dwCKeyCaps & DDCKEYCAPS_DESTOVERLAY){
			ovfx.dckDestColorkey.dwColorSpaceLowValue = DDColorMatch(lpDDSPrimary,RGB(0, 0, 0));
			ovfx.dckDestColorkey.dwColorSpaceHighValue = DDColorMatch(lpDDSPrimary,RGB(0, 0, 0));
			dwUpdateFlags |= DDOVER_DDFX | DDOVER_KEYDESTOVERRIDE;
		}

		CheckBoundries();
		lpDDSOverlay->Blt(&rs, NULL, &rd, DDBLT_ASYNC, NULL);
		if(DD_OK!=(lpDDSOverlay->UpdateOverlay(&rs, lpDDSPrimary, &rd, dwUpdateFlags, &ovfx)))
			throw "Failed DDOverlayUpdate";
		lpDDSOverlay->UpdateOverlay(NULL, lpDDSPrimary, NULL, DDOVER_HIDE, NULL);
		}
#if 0

	if(NESTER_settings.nes.graphics.WindowMode_2xsai)
	{
		int ret;
		if(lpDDSOverlay)
			ret = lpDDSOverlay->Lock(NULL, &ddsd, DDLOCK_WAIT, NULL);
		else
			ret = lpDDSBack->Lock(NULL, &ddsd, DDLOCK_WAIT, NULL);
		if(DD_OK == ret){
			if(lpDDSOverlay)
				lpDDSOverlay->Unlock(NULL);
			else
				lpDDSBack->Unlock(NULL);
			BitDepth = ddsd.ddpfPixelFormat.dwRGBBitCount;
			if(BitDepth!=8){
				buffer_16bit = (WORD *)malloc((GB_SCREEN_WIDTH+4)*(GB_SCREEN_HEIGHT+4) * 2);
				if(BitDepth==16){
					if(ddsd.ddpfPixelFormat.dwGBitMask == 0x7E0){
						BitGreen=1;
						Init_2xSaI(565);
					}
					else{
						Init_2xSaI(555);
					}
				}
				else{
					BitGreen=1;
					Init_2xSaI(565);
					buffer_16bit_bouble = (WORD *)malloc((GB_SCREEN_WIDTH+4)*(GB_SCREEN_HEIGHT+4) * 2*4);
				}
				switch(NESTER_settings.nes.graphics.WindowMode_2xsaiType){
					case 0:
						Func_2xSai = _2xSaI;
						break;
					case 1:
						Func_2xSai = Super2xSaI;
						break;
					case 2:
						Func_2xSai = SuperEagle;
						break;
					case 3:
						Func_2xSai = nnn_2xSaI;
						break;
					default:
						Func_2xSai = _2xSaI;
						break;
				}
				f_2xsai = 1;
			}
		}
	}
#endif
  } catch(...) {
    if(hBmp)     { DeleteObject(hBmp); }
    if(screenDC) { ReleaseDC(window_handle, screenDC); screenDC = NULL; }
    if(bmInfo)   { delete bmInfo; bmInfo = NULL; }
	if(clipper){ clipper->Release(); clipper=NULL; }
	if(lpDDSOverlay){ lpDDSOverlay->Release(); lpDDSOverlay=NULL; }
	if(lpDDSMsg){ lpDDSMsg->Release(); lpDDSMsg=NULL; }
	if(lpDDSBack){ lpDDSBack->Release(); lpDDSBack=NULL; }
	if(lpDDSPrimary){ lpDDSPrimary->Release(); lpDDSPrimary=NULL; }
	if(lpDD){ lpDD->Release(); lpDD = NULL; }
	if(buffer_16bit){ free(buffer_16bit); buffer_16bit=NULL; }
	if(buffer_16bit_bouble){ free(buffer_16bit_bouble); buffer_16bit_bouble=NULL; }
    throw;
  }
}

win32_windowed_GB_screen_mgr::~win32_windowed_GB_screen_mgr()
{
	if(avi_rec)
		end_avirec();
	if(buffer_16bit){
		free(buffer_16bit);
		buffer_16bit=NULL;
	}
	if(buffer_16bit_bouble){
		free(buffer_16bit_bouble);
		buffer_16bit_bouble=NULL;
	}
	
	if(clipper){
		clipper->Release();
		clipper=NULL;
	}
	if(lpDDSOverlay)
    {
      lpDDSOverlay->UpdateOverlay(NULL, lpDDSPrimary, NULL, DDOVER_HIDE, NULL);
      lpDDSOverlay->Release();
      lpDDSOverlay=NULL;
    }
	if(lpDDSMsg){
		lpDDSMsg->Release();
		lpDDSMsg=NULL;
	}
	if(lpDDSBack){
		lpDDSBack->Release();
		lpDDSBack=NULL;
	}
	if(lpDDSPrimary){
		lpDDSPrimary->Release();
		lpDDSPrimary=NULL;
	}
	if(lpDD){
		lpDD->Release();
		lpDD = NULL;
	}
  if(oldBmp && bmpDC)    { SelectBitmap(bmpDC, oldBmp); oldBmp = NULL; }
  if(screenDC) { ReleaseDC(window_handle, screenDC); screenDC = NULL; }
  if(bmpDC)    { DeleteDC(bmpDC); bmpDC = NULL; }
  if(hBmp)     { DeleteObject(hBmp); }
  if(bmInfo)   { delete bmInfo; bmInfo = NULL; }
}


boolean win32_windowed_GB_screen_mgr::lock(pixmap& p)
{
  p.height = GB_SCREEN_HEIGHT;
  p.width  = GB_SCREEN_WIDTH;
  p.pitch  = GB_SCREEN_WIDTH<<2;
  p.data   = buffer;
  return TRUE;
}


boolean win32_windowed_GB_screen_mgr::unlock()
{
  blown_up = 0;
  return TRUE;
}


void win32_windowed_GB_screen_mgr::blt()
{
  RECT dest;

  oldBmp = 0;
  bmpDC = 0;
  screenDC = 0;
  HDC hdcSurf, hdcSurf2;    // The handle to the Overlay's DC

  try {
	  // avi record
	  if(avi_rec)
		  frame_avirec();

    screenDC = GetDC(window_handle);
    if(screenDC == NULL)
      throw "GetDC failed in win32_windowed_GB_screen_mgr::blt";

    bmpDC = CreateCompatibleDC(screenDC);
    if(!bmpDC)
      throw "CreateCompatibleDC failed in win32_windowed_GB_screen_mgr::blt";

    oldBmp = SelectBitmap(bmpDC, hBmp);
    if(oldBmp == NULL)
      throw "SelectBitmap failed in win32_windowed_GB_screen_mgr::blt";

    if(!GetClientRect(window_handle, &dest))
      throw "GetClientRect failed in win32_windowed_GB_screen_mgr::blt";

	if(Mainwindowsbh){
		dest.bottom-=Mainwindowsbhs;
	}

//    if( NESTER_settings.nes.graphics.osd.double_size )
    {
      if( NESTER_settings.nes.graphics.EmulateTVScanline && !g_PreviewMode)
      {
		  emulateTVScanline();
      }
	  else if(f_2xsai&& !g_PreviewMode){
		  int ret;
		  if(BitGreen)
			  convto16_565bitpalette((DWORD *)&bmInfo->bmiPalette, palette_16bit);
		  else
			  convto16_555bitpalette((DWORD *)&bmInfo->bmiPalette, palette_16bit);
		  scrconv8_16for2xsai(&buffer[(GB_SCREEN_WIDTH<<1)], (unsigned char *)&buffer_16bit[(GB_SCREEN_WIDTH<<1)], palette_16bit,
			  GB_SCREEN_WIDTH, GB_SCREEN_HEIGHT, GB_SCREEN_WIDTH<<1, (GB_SCREEN_WIDTH<<1));
		  if(lpDDSOverlay)
			  ret = lpDDSOverlay->Lock(NULL, &ddsd, DDLOCK_WAIT, NULL);
		  else
			  ret = lpDDSBack->Lock(NULL, &ddsd, DDLOCK_WAIT, NULL);
		  if(DD_OK == ret){
			  switch(BitDepth){
				  case 16:
					  Func_2xSai((unsigned char *)&buffer_16bit[(GB_SCREEN_WIDTH*2)], (GB_SCREEN_WIDTH*2), NULL, (unsigned char *)ddsd.lpSurface, ddsd.lPitch, GB_SCREEN_WIDTH, GB_SCREEN_HEIGHT);
					  break;
				  case 24:
					  Func_2xSai((unsigned char *)&buffer_16bit[(GB_SCREEN_WIDTH*2)], (GB_SCREEN_WIDTH*2), NULL, (unsigned char *)buffer_16bit_bouble, GB_SCREEN_WIDTH<<2, GB_SCREEN_WIDTH, GB_SCREEN_HEIGHT);
					  scrconv16_24((unsigned char *)buffer_16bit_bouble, (unsigned char *)ddsd.lpSurface, GB_SCREEN_WIDTH<<1, GB_SCREEN_HEIGHT<<1, GB_SCREEN_WIDTH<<2, ddsd.lPitch);
					  break;
				  case 32:
					  Func_2xSai((unsigned char *)&buffer_16bit[(GB_SCREEN_WIDTH*2)], (GB_SCREEN_WIDTH*2), NULL, (unsigned char *)buffer_16bit_bouble, GB_SCREEN_WIDTH<<2, GB_SCREEN_WIDTH, GB_SCREEN_HEIGHT);
					  scrconv16_32((unsigned char *)buffer_16bit_bouble, (unsigned char *)ddsd.lpSurface, GB_SCREEN_WIDTH<<1, GB_SCREEN_HEIGHT<<1, GB_SCREEN_WIDTH<<2, ddsd.lPitch);
					  break;
			  }
			  if(lpDDSOverlay){
		  		  lpDDSOverlay->Unlock(NULL);
				  POINT pt;
				  pt.x=dest.left;
				  pt.y=dest.top;
				  ClientToScreen(window_handle, &pt);

				  if(NESTER_settings.nes.graphics.EmulateTVScanline||f_2xsai){
					  rs.right=GB_SCREEN_WIDTH<<1;
					  rs.bottom=GB_SCREEN_HEIGHT<<1;
				  }
				  else{
					  rs.right=GB_SCREEN_WIDTH;
					  rs.bottom=GB_SCREEN_HEIGHT;
				  }
				  rd.top=pt.y, rd.left=pt.x, rd.bottom=pt.y+dest.bottom, rd.right=pt.x+dest.right;
				  CheckBoundries();
				  lpDDSOverlay->UpdateOverlay(&rs, lpDDSPrimary, &rd, dwUpdateFlags, &ovfx);
				  goto _Blt_Finally;
			  }
			  else {
				  lpDDSBack->Unlock(NULL);
				  POINT pt;
				  RECT rsrc, d;
				  pt.x=dest.left;
				  pt.y=dest.top;
				  d=dest;
				  ClientToScreen(window_handle, &pt);
				  if(NESTER_settings.nes.graphics.EmulateTVScanline||f_2xsai){
					  rsrc.right=GB_SCREEN_WIDTH<<1;
					  rsrc.bottom=GB_SCREEN_HEIGHT<<1;
				  }
				  else{
					  rsrc.right=GB_SCREEN_WIDTH;
					  rsrc.bottom=GB_SCREEN_HEIGHT;
				  }
				  rsrc.top=0, rsrc.left=0;
				  d.top=pt.y, d.left=pt.x, d.bottom+=pt.y, d.right+=pt.x;
				  //			  lpDDSPrimary->BltFast(pt.x, pt.y, lpDDSBack, &rsrc, DDBLTFAST_WAIT );
				  lpDDSPrimary->Blt(&d, lpDDSBack, &rsrc, DDBLT_ASYNC, NULL);
				  goto _Blt_Finally;
			  }
		  }
	  }
	}
	if(lpDDSOverlay && NESTER_settings.nes.graphics.WindowModeUseDdrawOverlay){//
		POINT pt;
//		HRESULT hRet;

		pt.x=dest.left;
		pt.y=dest.top;
		ClientToScreen(window_handle, &pt);

		lpDDSOverlay->GetDC(&hdcSurf2);
//		if(window_handle == GetFocus()){
		if(g_PreviewMode){
			rs.top=0, rs.left=0, rs.right=GB_SCREEN_WIDTH, rs.bottom=GB_SCREEN_HEIGHT;
			rd.top=pt.y+g_Preview_State.PreviewScreenDrawRect.top, rd.left=pt.x+g_Preview_State.PreviewScreenDrawRect.left;
			rd.bottom=rd.top+rs.bottom, rd.right=rd.left+rs.right;
			BitBlt(hdcSurf2, 0, //, // // upper left dest x
			  0, // // upper left dest y
			  rs.right,
			  rs.bottom,
			  bmpDC,
			  0, // upper left source x
			  0, // upper left source y
			  SRCCOPY);
		}
		else{
			if(NESTER_settings.nes.graphics.EmulateTVScanline){
				rs.right=GB_SCREEN_WIDTH<<1;
				rs.bottom=GB_SCREEN_HEIGHT<<1;
			}
			else{
				rs.right=GB_SCREEN_WIDTH;
				rs.bottom=GB_SCREEN_HEIGHT;
			}
			rd.top=pt.y, rd.left=pt.x, rd.bottom=pt.y+dest.bottom, rd.right=pt.x+dest.right;
			BitBlt(hdcSurf2, 0, // upper left dest x
				  0, // upper left dest y
				  rs.right,
				  rs.bottom,
//				  (NESTER_settings.nes.graphics.EmulateTVScanline)? get_viewable_width()<<1:get_viewable_width(), //dest.right-dest.left, // width of dest
//				  (NESTER_settings.nes.graphics.EmulateTVScanline)? get_viewable_height()<<1:get_viewable_height(), //dest.bottom-dest.top, // height of dest
				  bmpDC,
				  0, //get_viewable_area_x_offset(), // upper left source x
				  0, //get_viewable_area_y_offset(), // upper left source y
				  SRCCOPY);
		}
//		lpDDSOverlay->SetOverlayPosition(pt.x, pt.y);
		lpDDSOverlay->ReleaseDC(hdcSurf2);
		CheckBoundries();
        lpDDSOverlay->UpdateOverlay(&rs, lpDDSPrimary, &rd, dwUpdateFlags, &ovfx);
//		}
//		rs.left=0,rs.top=0, rs.bottom=get_viewable_area_y_offset(), rs.right=get_viewable_area_x_offset();
//		rd.left=pt.x,rd.top=pt.y, rd.bottom=dest.bottom-dest.top+pt.y, rd.right=dest.right-dest.left+pt.x;
//		CheckBoundries();
//		lpDDSOverlay->SetOverlayPosition(pt.x, pt.y);
//		lpDDSOverlay->Flip(NULL, DDFLIP_WAIT);
	}
	else{
		POINT pt;
		HRESULT hRet;
		RECT rsrc, d;

		pt.x=dest.left;
		pt.y=dest.top;
		d=dest;
		ClientToScreen(window_handle, &pt);
#if 1
		hRet = lpDDSBack->GetDC(&hdcSurf);
		if(hRet!=DD_OK)
			throw "getdc";

		if(g_PreviewMode){
			rsrc.top=0, rsrc.left=0, rsrc.right=GB_SCREEN_WIDTH, rsrc.bottom=GB_SCREEN_HEIGHT;
			d.top=pt.y+g_Preview_State.PreviewScreenDrawRect.top, d.left=pt.x+g_Preview_State.PreviewScreenDrawRect.left;
			d.bottom=d.top+rsrc.bottom, d.right=d.left+rsrc.right;
			BitBlt(hdcSurf, 0, //, // // upper left dest x
			  0, // // upper left dest y
			  rsrc.right,
			  rsrc.bottom,
			  bmpDC,
			  0, // upper left source x
			  0, // upper left source y
			  SRCCOPY);
		}
		else{
#if 1
			if(NESTER_settings.nes.graphics.EmulateTVScanline||f_2xsai){
				rsrc.right=GB_SCREEN_WIDTH<<1;
				rsrc.bottom=GB_SCREEN_HEIGHT<<1;
			}
			else{
				rsrc.right=GB_SCREEN_WIDTH;
				rsrc.bottom=GB_SCREEN_HEIGHT;
			}
			rsrc.top=0, rsrc.left=0; //, rsrc.right=(NESTER_settings.nes.graphics.EmulateTVScanline)? get_viewable_width()<<1:get_viewable_width(), /*dest.right,*/ rsrc.bottom=(NESTER_settings.nes.graphics.EmulateTVScanline)? get_viewable_height()<<1:get_viewable_height(); //dest.bottom;
			d.top=pt.y, d.left=pt.x, d.bottom+=pt.y, d.right+=pt.x;
			BitBlt(hdcSurf, 0, //, // // upper left dest x
				  0, // // upper left dest y
				  rsrc.right,
				  rsrc.bottom,
//				  (NESTER_settings.nes.graphics.EmulateTVScanline)? GB_SCREEN_WIDTH<<1:GB_SCREEN_WIDTH, //dest.right-dest.left, // width of dest
//				  (NESTER_settings.nes.graphics.EmulateTVScanline)? GB_SCREEN_HEIGHT<<1:GB_SCREEN_HEIGHT, //dest.bottom-dest.top, // height of dest
				  bmpDC,
				  0, // upper left source x
				  0, // upper left source y
				  SRCCOPY);
		}
		lpDDSBack->ReleaseDC(hdcSurf);
#else
		lpDDSBack->ReleaseDC(hdcSurf);
		memset(&ddsd, 0, sizeof(ddsd));
		ddsd.dwSize=sizeof(ddsd);
		if(DD_OK == lpDDSBack->Lock(NULL, &ddsd, DDLOCK_WAIT, NULL)){
			ddrawblt_8bit(&ddsd, (DWORD *)&bmInfo->bmiPalette, (unsigned char *)buffer, get_viewable_height());
			lpDDSBack->Unlock(NULL);
		}
		}
#endif
		lpDDSPrimary->Blt(&d, lpDDSBack, &rsrc, /*DDBLT_ASYNC*/ DDBLT_WAIT , NULL);
#else
		unsigned char *tb=NULL;
		int width,height;
		height = dest.bottom-dest.top, width = dest.right-dest.left;
		tb= (unsigned char*)malloc(width*height);
		if(tb){
			scaling(tb, height, width);
			lpDDSPrimary->Lock(NULL, &ddsd, 0, NULL);
			memcpy(ddsd.lpSurface, tb, width*height);
			lpDDSPrimary->Unlock(NULL);
			free(tb);
		}
#endif
	}

_Blt_Finally:

    if(oldBmp && bmpDC)    { SelectBitmap(bmpDC, oldBmp); oldBmp = NULL; }
    if(bmpDC)    { DeleteDC(bmpDC); bmpDC = NULL; }
    if(screenDC) { ReleaseDC(window_handle, screenDC); screenDC = NULL; }

  } catch(const char* IFDEBUG(s)) {
    if(oldBmp && bmpDC)    { SelectBitmap(bmpDC, oldBmp); oldBmp = NULL; }
    if(bmpDC)    { DeleteDC(bmpDC); bmpDC = NULL; }
    if(screenDC) { ReleaseDC(window_handle, screenDC); screenDC = NULL; }
    LOG(s << endl);
  }
}

void win32_windowed_GB_screen_mgr::clear(PIXEL color)
{
  PIXEL* p;
  p = buffer;
  uint32 height = GB_SCREEN_HEIGHT << 1;
  uint32 width = GB_SCREEN_WIDTH << 1;
  for(uint32 i = 0; i < height; i++)
  {
    memset(p, color, width);
    p += width;
  }
}



void win32_windowed_GB_screen_mgr::emulateTVScanline()
{
  if(blown_up) return;
#if 0
  unsigned char *d_base;
  unsigned char *s_base;
  unsigned char *d;
  unsigned char *s;
  uint32 i,j;
  const uint32 pitch = GB_SCREEN_HEIGHT<<1;

  // source pointer
  s_base = &buffer[get_viewable_area_x_offset() + (pitch * (get_viewable_area_y_offset() + (viewable_height-1)))];

  // destination pointer
  d_base = &buffer[get_viewable_area_x_offset() + pitch +
    (pitch * (get_viewable_area_y_offset() + ( (viewable_height-1) << 1 ) ) )];

  for(i = 0; i < viewable_height; i++)
  {
    // stretch the source line to the destination line
    s = s_base;
    d = d_base;
    for(j = 0; j < viewable_width; j++)
    {
      *(d++) = *s;
      *(d++) = *s;
      s++;
    }
    d_base -= pitch;
    
	// draw TV scanline
    memset( d_base, 0x00, pitch );
    d_base -= pitch;
    s_base -= pitch;
  }
  blown_up = 1;
#endif
}


void win32_windowed_GB_screen_mgr::shot_screen( char *szFileName )
{
#if 0
  const DWORD x_offset = get_viewable_area_x_offset();
  const DWORD y_offset = get_viewable_area_y_offset();
  const DWORD pitch = get_width() << 1;
  int w, h, i,j,k;
  unsigned char *sdt = NULL;
  PALETTEENTRY pal[256];
  w = get_viewable_width();
  h = get_viewable_height();
  sdt = (unsigned char *)malloc(w*h);
  if(sdt == NULL)
	  return;
  if(blown_up){
	  int dp=pitch<<1;
	  for(i=0,j=0,k=y_offset*dp+x_offset+pitch; i<h; i++, j+=w, k+=dp){
		  memcpy(&sdt[j], &buffer[k], w);
	  }
  }
  else{
	  for(i=0,j=0,k=y_offset*pitch+x_offset; i<h; i++, j+=w, k+=pitch){
		  memcpy(&sdt[j], &buffer[k], w);
	  }
  }
  for(i=0;i<0x100;i++){
	  pal[i].peBlue	=bmInfo->bmiPalette[i].rgbBlue;
	  pal[i].peGreen=bmInfo->bmiPalette[i].rgbGreen;
	  pal[i].peRed	=bmInfo->bmiPalette[i].rgbRed;
	  pal[i].peFlags=0;
  }
  screenshot_save_8bit(szFileName, w, h, pal, sdt);
  free(sdt);
#endif
}

int win32_windowed_GB_screen_mgr::CheckOverlaySupport(){
    memset(&ddcaps, 0, sizeof(ddcaps));
    ddcaps.dwSize = sizeof(ddcaps);
    if (lpDD->GetCaps(&ddcaps, 0))
        return FALSE;
    if (!(ddcaps.dwCaps & DDCAPS_OVERLAY))
        return FALSE;
    if (!(ddcaps.dwCaps & DDCAPS_OVERLAYSTRETCH))
        return FALSE;
    return TRUE;
}


int win32_windowed_GB_screen_mgr::DDOverlayInit(){
//	DDCOLORKEY	ddck;
    DDSURFACEDESC2              ddsd;  // DirectDraw surface descriptor
    HRESULT                     hRet;
    DDPIXELFORMAT               ddpfOverlayFormat =	{
		sizeof(DDPIXELFORMAT), DDPF_RGB, 0, 16, 0xF800, 0x07e0, 0x001F,   // 16 bit RGB 5:6:5
			 0};
		RECT dest;
		GetClientRect(window_handle, &dest);

    memset(&ddsd, 0, sizeof(ddsd));
    ddsd.dwSize = sizeof(ddsd);
    ddsd.ddsCaps.dwCaps = DDSCAPS_OVERLAY | DDSCAPS_VIDEOMEMORY |DDCAPS_OVERLAYSTRETCH ;
    ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH | DDSD_PIXELFORMAT;
    ddsd.dwBackBufferCount = 0;
	ddsd.dwWidth	=(NESTER_settings.nes.graphics.EmulateTVScanline||f_2xsai)?GB_SCREEN_WIDTH<<1:GB_SCREEN_WIDTH; //(NESTER_settings.nes.graphics.EmulateTVScanline)? get_viewable_width()<<1:get_viewable_width();
	ddsd.dwHeight	=(NESTER_settings.nes.graphics.EmulateTVScanline||f_2xsai)?GB_SCREEN_HEIGHT<<1:GB_SCREEN_HEIGHT; //(NESTER_settings.nes.graphics.EmulateTVScanline)? get_viewable_height()<<1:get_viewable_height(); 
    ddsd.ddpfPixelFormat = ddpfOverlayFormat;  // Use 16 bit RGB 5:6:5 pixel format

    // Attempt to create the surface with theses settings
    hRet = lpDD->CreateSurface(&ddsd, &lpDDSOverlay, NULL);
    if (hRet != DD_OK)
        return FALSE;
/*	ZeroMemory(&ddck, sizeof(DDCOLORKEY));
	ddck.dwColorSpaceLowValue	=0;
	ddck.dwColorSpaceHighValue	=0;
	lpDDSOverlay->SetColorKey(DDCKEY_SRCBLT,&ddck);
*/    return TRUE;
}


int win32_windowed_GB_screen_mgr::DDPrimaryInit(){
    HRESULT                     hRet;
//    DDSURFACEDESC2              ddsd;

    memset(&ddsd, 0, sizeof(ddsd));
    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_CAPS;
    ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
    hRet = lpDD->CreateSurface(&ddsd, &lpDDSPrimary, NULL);
    if (hRet != DD_OK)
        return FALSE;
    return TRUE;
}


void win32_windowed_GB_screen_mgr::CheckBoundries(){
/*
    if ((ddcaps.dwCaps & DDCAPS_OVERLAYSTRETCH) && (ddcaps.dwMinOverlayStretch)
        && (g_dwXRatio < ddcaps.dwMinOverlayStretch))
    {
        rd.right = 2 * GetSystemMetrics(SM_CXSIZEFRAME) + rd.left + (get_viewable_width()
                                 * (ddcaps.dwMinOverlayStretch + 1)) / 1000;
    }
    if ((ddcaps.dwCaps & DDCAPS_OVERLAYSTRETCH) && (ddcaps.dwMaxOverlayStretch)
        && (g_dwXRatio > ddcaps.dwMaxOverlayStretch))
    {
        rd.right = 2 * GetSystemMetrics(SM_CXSIZEFRAME) + rd.left + (get_viewable_height()
                               * (ddcaps.dwMaxOverlayStretch + 999)) / 1000;
    }

    // Recalculate the ratio's for the upcoming calculations
    g_dwXRatio = (rd.right - rd.left) * 1000 / (rs.right - rs.left);
    g_dwYRatio = (rd.bottom - rd.top) * 1000 / (rs.bottom - rs.top);

    // Check to make sure we're within the screen's boundries, if not then fix
    // the problem by adjusting the source rectangle which we draw from.
    if (rd.left < 0)
    {
        rs.left = -rd.left * 1000 / g_dwXRatio;
        rd.left = 0;
    }
    if (rd.right > GetSystemMetrics(SM_CXSCREEN))
    {
        rs.right = get_viewable_width()- ((rd.right - GetSystemMetrics(SM_CXSCREEN)) *
                                1000 / g_dwXRatio);
        rd.right = GetSystemMetrics(SM_CXSCREEN);
    }
    if (rd.bottom > GetSystemMetrics(SM_CYSCREEN))
    {
        rs.bottom = get_viewable_height() - ((rd.bottom - GetSystemMetrics(SM_CYSCREEN))
                                 * 1000 / g_dwYRatio);
        rd.bottom = GetSystemMetrics(SM_CYSCREEN);
    }
    // I don't know how useful this is... but just in case someone can do it - here's the check.
    if (rd.top < 0)
    {
        rs.top = -rd.top * 1000 / g_dwYRatio;
        rd.top = 0;
    }
*/
    if ((ddcaps.dwCaps & DDCAPS_ALIGNBOUNDARYSRC) && ddcaps.dwAlignBoundarySrc)
        rs.left = (rs.left + ddcaps.dwAlignBoundarySrc / 2) & -(signed)
            (ddcaps.dwAlignBoundarySrc);
    if ((ddcaps.dwCaps & DDCAPS_ALIGNSIZESRC) && ddcaps.dwAlignSizeSrc)
        rs.right = rs.left + (rs.right - rs.left + ddcaps.dwAlignSizeSrc
                                   / 2) & -(signed) (ddcaps.dwAlignSizeSrc);
    if ((ddcaps.dwCaps & DDCAPS_ALIGNBOUNDARYDEST) && ddcaps.dwAlignBoundaryDest)
        rd.left = (rd.left + ddcaps.dwAlignBoundaryDest / 2) & -(signed)
            (ddcaps.dwAlignBoundaryDest);
    if ((ddcaps.dwCaps & DDCAPS_ALIGNSIZEDEST) && ddcaps.dwAlignSizeDest)
        rd.right = rd.left + (rd.right - rd.left) & -(signed) (ddcaps.dwAlignSizeDest);
}


int win32_windowed_GB_screen_mgr::create_backsurface()
{
	DDSURFACEDESC2	ddsd;
	ZeroMemory(&ddsd,sizeof(ddsd));
	ddsd.dwSize	=sizeof(ddsd);
	ddsd.dwFlags=DDSD_CAPS|DDSD_HEIGHT|DDSD_WIDTH; 
	ddsd.ddsCaps.dwCaps=DDSCAPS_OFFSCREENPLAIN; //| DDSCAPS_SYSTEMMEMORY;
	if(NESTER_settings.nes.graphics.WindowModeBackBuffM)
		ddsd.ddsCaps.dwCaps |= DDSCAPS_SYSTEMMEMORY;
	else
		ddsd.ddsCaps.dwCaps |= DDSCAPS_VIDEOMEMORY;

	ddsd.dwWidth	=GB_SCREEN_WIDTH*2;//(NESTER_settings.nes.graphics.EmulateTVScanline )? get_viewable_width()<<1:get_viewable_width();
	ddsd.dwHeight	=GB_SCREEN_HEIGHT*2;//(NESTER_settings.nes.graphics.EmulateTVScanline )? get_viewable_height()<<1:get_viewable_height(); 
	if(lpDD->CreateSurface(&ddsd,&lpDDSBack,NULL)!=DD_OK)
		return 0;
	return 1;
}



void win32_windowed_GB_screen_mgr::nnnManuEnable(unsigned char flag){
	Menuflag=flag;
	if(flag && lpDDSOverlay && NESTER_settings.nes.graphics.WindowModeUseDdrawOverlay){
		lpDDSOverlay->UpdateOverlay(NULL, lpDDSPrimary, NULL, DDOVER_HIDE, NULL);
	}
}

void win32_windowed_GB_screen_mgr::EndEmu(){
	if(lpDDSOverlay && NESTER_settings.nes.graphics.WindowModeUseDdrawOverlay){
		lpDDSOverlay->UpdateOverlay(NULL, lpDDSPrimary, NULL, DDOVER_HIDE, NULL);
	}
}


void win32_windowed_GB_screen_mgr::StartEmu(){
}



#if 0
int DDColorMatch(IDirectDrawSurface7 * pdds, COLORREF rgb)
{
    COLORREF                rgbT;
    HDC                     hdc;
    DWORD                   dw = CLR_INVALID;
    DDSURFACEDESC2          ddsd;
    HRESULT                 hres;

    //
    //  Use GDI SetPixel to color match for us
    //
    if (rgb != CLR_INVALID && pdds->GetDC(&hdc) == DD_OK)
    {
        rgbT = GetPixel(hdc, 0, 0);     // Save current pixel value
        SetPixel(hdc, 0, 0, rgb);       // Set our value
        pdds->ReleaseDC(hdc);
    }
    //
    // Now lock the surface so we can read back the converted color
    //
    ddsd.dwSize = sizeof(ddsd);
    while ((hres = pdds->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING)
        ;
    if (hres == DD_OK)
    {
        dw = *(DWORD *) ddsd.lpSurface;                 // Get DWORD
        if (ddsd.ddpfPixelFormat.dwRGBBitCount < 32)
            dw &= (1 << ddsd.ddpfPixelFormat.dwRGBBitCount) - 1;  // Mask it to bpp
        pdds->Unlock(NULL);
    }
    //
    //  Now put the color that was there back.
    //
    if (rgb != CLR_INVALID && pdds->GetDC(&hdc) == DD_OK)
    {
        SetPixel(hdc, 0, 0, rgbT);
        pdds->ReleaseDC(hdc);
    }
    return dw;
}
#endif


int win32_windowed_GB_screen_mgr::start_avirec(char *fn){
#if 0
	avi_rec = recavifilestart(fn, get_viewable_width(), get_viewable_height());
	return avi_rec;
#endif
	return 0;
}


void win32_windowed_GB_screen_mgr::frame_avirec(){
#if 0
  avi_counter^=1;
  if(!avi_counter){
	  return;
  }
  const DWORD x_offset = get_viewable_area_x_offset();
  const DWORD y_offset = get_viewable_area_y_offset();
  const DWORD pitch = get_width() << 1;
  int w, h, i,j,k;
  unsigned char *sdt = NULL;
  w = get_viewable_width();
  h = get_viewable_height();
  sdt = (unsigned char *)malloc(w*h);
  if(sdt == NULL)
	  return;
  if(blown_up){
	  int dp=pitch<<1;
	  for(i=0,j=0,k=(y_offset+h-1)*dp+x_offset; i<h; i++, k-=dp){
		  for(int x=0,dk=k; x<w; x++, dk+=2){
		  	  sdt[j++] = buffer[dk];
		  }
	  }
  }
  else{
	  for(i=0,j=0,k=(y_offset+h-1)*pitch+x_offset; i<h; i++, j+=w, k-=pitch){
		  memcpy(&sdt[j], &buffer[k], w);
	  }
  }
  recavifilewriteflame(sdt);
  free(sdt);
#endif
}


void win32_windowed_GB_screen_mgr::end_avirec(){
	if(avi_rec)
		recavifilerelease();
}


